<script setup>
  import { onMounted } from 'vue';
  import { useStore } from 'vuex';
  import { useRouter } from 'vue-router';

  const props = defineProps(['last_email']);
  const store = useStore();
  const router = useRouter();
  const emit = defineEmits(['user-authentificated'])

  let email = '';
  let password = '';

  onMounted(() => {
    if(props.last_email !== undefined){
      email = props.last_email;
    }
    if(store.getters.isAuthentificated === true){
      router.push('/');
    }
  })

  function sendLogin() {
    console.log('envoie du formulaire de connection...')
    fetch('https://api.mangaUpdate.fr/api/login', {
      method: 'POST',
      headers: {'Content-Type': 'application/json'},
      body: JSON.stringify({
        'username':email,
        'password':password
      })
    })
    .then(response => response.json())
    .then(data => {
      if(data.message === 'authentificated'){
        let payload = {authentificated : true, token : data.token, role : data.role}
        store.commit('change', payload)
        location.reload()
      }else{
        document.getElementById('error').innerText = data.error;
      }
    })
  }
</script>

<template>
  <main class="container mx-auto flex flex-col items-center mt-8">
    <h3 class="text-2xl mb-8">Connexion</h3>
    <form method="post" v-on:submit.prevent="sendLogin" class="formulaire_login text-lg flex items-center flex-col">
      <div class="flex flex-col gap-2 mb-4 items-center">
        <input type='email' name="mail" id="inputMail" class="rounded text-black border-2 px-2" v-model="email" placeholder="Email" required>
      </div>
      <div class="flex flex-col gap-2 mb-2 items-center">
        <input type="password" name="password" id="inputPassword" class="rounded text-black border-2 px-2" v-model="password" placeholder="Mot de passe" required>
      </div>
      <button type="submit" class='rounded my-4 px-2 py-1 bg-gray-400 text-black hover:bg-white border-2 hover:border-grey duration-200'>Se connecter</button>
    </form>
    <div id="inscription">
      <a v-on:click="()=>{router.push('/resetPassword')}" class='text-green-600'>Mot de passe oublié</a> / 
      <a v-on:click="()=>{router.push('/register')}" class="text-green-600">Première connexion</a>
    </div>
    <div id="error" class="my-3 text-red-500">
    </div>
  </main>
</template>

<style>

@tailwind base;
@tailwind components;
@tailwind utilities;

#inscription{
  cursor: pointer;
}

@media (min-width: 1024px) {
  .about {
    min-height: 100vh;
    display: flex;
    align-items: center;
  }
}
</style>